function f = funcQUAIDSSR1_Ecma2_TasteShifters2(x)

global w1 w2 w3 w4 const lx rlp1 rlp2 rlp3 rlp4 rp1 rp2 rp3 rp4 lp5 AgeHusband AgeWife Homeowner
%%
% We take account of adding-up and impose homogeneity (relative prices used) 
ngood=4;
nobs=length(const);
%%
logap=x(6).*rlp1.*rlp1+x(7).*rlp1.*rlp2+x(8).*rlp1.*rlp3+x(9).*rlp1.*rlp4;
logap=logap+x(15).*rlp2.*rlp1+x(16).*rlp2.*rlp2+x(17).*rlp2.*rlp3+x(18).*rlp2.*rlp4;
logap=logap+x(24).*rlp3.*rlp1+x(25).*rlp3.*rlp2+x(26).*rlp3.*rlp3+x(27).*rlp3.*rlp4;
logap=logap+x(33).*rlp4.*rlp1+x(34).*rlp4.*rlp2+x(35).*rlp4.*rlp3+x(36).*rlp4.*rlp4;
logap=0.5*logap;
logap=logap+x(1).*rlp1+x(10).*rlp2+x(19).*rlp3+x(28).*rlp4+2*const+lp5;

bp=(rp1.^x(4)).*(rp2.^x(13)).*(rp3.^x(22)).*(rp4.^x(31));

rlx=lx-logap;
rlx2=rlx.^2;

X=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];
Z=X;

b=zeros(9,ngood);
nr=0;
for i=1:ngood
   for j=1:9
      nr=nr+1;
      b(j,i)=x(nr); 
   end
end

w=[w1 w2 w3 w4];
ew=zeros(nobs,ngood);
for i=1:ngood
    ew(:,i)=X*b(:,i);
end

u=zeros(nobs,ngood);

for i=1:ngood
   u(:,i)=w(:,i)-ew(:,i); 
end

vf=[u(:,1);u(:,2);u(:,3);u(:,4)]; 

f=vf'*vf;