% SR1 constraints
% 17/04/2013

function [c, ceq] = consQUAIDSSR1_Ecma2(x)
%%
G=[x(4) x(5) x(6) x(7); x(11) x(12) x(13) x(14); x(18) x(19) x(20) x(21); x(25) x(26) x(27) x(28)];

M=G-G';
%%
nn=5;
ceq=zeros((nn-3)*(nn-4)/2,1);
count=0;
for i=3:nn-1
    for k=i+1:nn-1
        count=count+1;
        ceq(count)=(M(1,2)*M(i,k))-(M(1,i)*M(2,k)-M(1,k)*M(2,i));
    end
end

c=[];